--[[------------------------------------------
Price import script for www.mtgmintcard.com
Authors: Goblin Hero, Stromglad1, Serenus
Last Update: 2014-07-05
--------------------------------------------]]

--[[ Table that describe sets available for price import
	  id: numerical database set id (can be found in "Database\Sets.txt" file)
   foil:	"N" - no foils in set, "Y" - foils in set, "O" - only foils in set
chinese: "N" - no chinese cards, "Y" - chinese cards, "O" - only chinese cards
    url:	price url suffix --]]
avsets =	{
	{id = 806, foil = "Y", chinese = "Y", url = "jou"},
	{id = 805, foil = "Y", chinese = "N", url = "ddm"},
	{id = 802, foil = "Y", chinese = "Y", url = "bng"},
	{id = 801, foil = "N", chinese = "N", url = "c13"},
	{id = 800, foil = "Y", chinese = "Y", url = "ths"},
	{id = 799, foil = "Y", chinese = "N", url = "hvm"},
	{id = 798, foil = "O", chinese = "N", url = "ftv"},
	{id = 797, foil = "Y", chinese = "Y", url = "m14"},
	{id = 796, foil = "Y", chinese = "N", url = "mm"},
	{id = 795, foil = "Y", chinese = "Y", url = "dgm"},
	{id = 794, foil = "Y", chinese = "N", url = "ddk"},
	{id = 793, foil = "Y", chinese = "Y", url = "gtc"},
	{id = 791, foil = "Y", chinese = "Y", url = "rtr"},
	{id = 790, foil = "Y", chinese = "N", url = "ddj"},
	{id = 789, foil = "O", chinese = "N", url = "fvr"},
	{id = 788, foil = "Y", chinese = "Y", url = "m13"},
	{id = 787, foil = "N", chinese = "N", url = "p12"},
	{id = 786, foil = "Y", chinese = "Y", url = "avr"},
	{id = 785, foil = "Y", chinese = "N", url = "ddi"},
	{id = 784, foil = "Y", chinese = "Y", url = "dka"},
	{id = 783, foil = "O", chinese = "N", url = "pd3"},
	{id = 782, foil = "Y", chinese = "Y", url = "isd"},
	{id = 781, foil = "Y", chinese = "N", url = "avn"},
	{id = 780, foil = "O", chinese = "N", url = "v11"},
	{id = 779, foil = "Y", chinese = "Y", url = "m12"},
	{id = 778, foil = "N", chinese = "N", url = "com"},
	{id = 777, foil = "Y", chinese = "N", url = "ddg"},
	{id = 776, foil = "Y", chinese = "Y", url = "nph"},
	{id = 775, foil = "Y", chinese = "Y", url = "mbs"},
	{id = 774, foil = "O", chinese = "N", url = "h10"},
	{id = 773, foil = "Y", chinese = "Y", url = "som"},
	{id = 772, foil = "Y", chinese = "N", url = "evt"},
	{id = 770, foil = "Y", chinese = "Y", url = "m11"},
	{id = 769, foil = "N", chinese = "N", url = "arc"},
	{id = 768, foil = "Y", chinese = "Y", url = "dpa"},
	{id = 767, foil = "Y", chinese = "Y", url = "roe"},
	{id = 766, foil = "N", chinese = "N", url = "pvc"},
	{id = 765, foil = "Y", chinese = "Y", url = "wwk"},
	{id = 764, foil = "O", chinese = "N", url = "h09"},
	{id = 763, foil = "Y", chinese = "N", url = "gvl"},
	{id = 762, foil = "Y", chinese = "Y", url = "zen"},
	{id = 759, foil = "Y", chinese = "Y", url = "m10"},
	{id = 758, foil = "Y", chinese = "Y", url = "arb"},
	{id = 757, foil = "Y", chinese = "N", url = "dvd"},
	{id = 756, foil = "Y", chinese = "Y", url = "con"},
	{id = 755, foil = "Y", chinese = "N", url = "jvc"},
	{id = 754, foil = "Y", chinese = "Y", url = "ala"},
	{id = 753, foil = "O", chinese = "N", url = "drb"},
	{id = 752, foil = "Y", chinese = "Y", url = "eve"},
	{id = 751, foil = "Y", chinese = "Y", url = "shm"},
	{id = 750, foil = "Y", chinese = "Y", url = "mor"},
	{id = 730, foil = "Y", chinese = "Y", url = "lrw"},
	{id = 720, foil = "Y", chinese = "Y", url = "10e"},
	{id = 710, foil = "Y", chinese = "Y", url = "fut"},
	{id = 700, foil = "Y", chinese = "Y", url = "plc"},
	{id = 690, foil = "Y", chinese = "N", url = "tsb"},
	{id = 680, foil = "Y", chinese = "N", url = "tsp"},
	{id = 670, foil = "Y", chinese = "N", url = "csp"},
	{id = 660, foil = "Y", chinese = "N", url = "dis"},
	{id = 650, foil = "Y", chinese = "N", url = "gpt"},
	{id = 640, foil = "Y", chinese = "N", url = "rav"},
	{id = 630, foil = "Y", chinese = "N", url = "9ed"},
	{id = 620, foil = "Y", chinese = "N", url = "sok"},
	{id = 610, foil = "Y", chinese = "N", url = "bok"},
	{id = 600, foil = "N", chinese = "N", url = "unh"},
	{id = 590, foil = "Y", chinese = "N", url = "chk"},
	{id = 580, foil = "Y", chinese = "N", url = "5dn"},
	{id = 570, foil = "Y", chinese = "N", url = "dst"},
	{id = 560, foil = "Y", chinese = "N", url = "mrd"},
	{id = 550, foil = "Y", chinese = "N", url = "8ed"},
	{id = 540, foil = "Y", chinese = "N", url = "scg"},
	{id = 530, foil = "Y", chinese = "N", url = "lgn"},
	{id = 520, foil = "Y", chinese = "N", url = "ons"},
	{id = 510, foil = "Y", chinese = "N", url = "jud"},
	{id = 500, foil = "Y", chinese = "N", url = "tor"},
	{id = 490, foil = "N", chinese = "N", url = "dkm"},
	{id = 480, foil = "Y", chinese = "N", url = "ody"},
	{id = 470, foil = "Y", chinese = "N", url = "apc"},
	{id = 460, foil = "Y", chinese = "N", url = "7ed"},
	{id = 450, foil = "Y", chinese = "N", url = "pls"},
	{id = 440, foil = "Y", chinese = "N", url = "btd"},
	{id = 430, foil = "Y", chinese = "N", url = "inv"},
	{id = 420, foil = "Y", chinese = "N", url = "pcy"},
	{id = 410, foil = "Y", chinese = "N", url = "nms"},
	{id = 405, foil = "Y", chinese = "N", url = "brb"},
	{id = 400, foil = "Y", chinese = "N", url = "mmq"},
	{id = 370, foil = "Y", chinese = "N", url = "uds"},
	{id = 360, foil = "Y", chinese = "N", url = "6ed"},
	{id = 350, foil = "Y", chinese = "N", url = "ulg"},
	{id = 340, foil = "N", chinese = "N", url = "ath"},
	{id = 330, foil = "Y", chinese = "N", url = "usg"},
	{id = 320, foil = "N", chinese = "N", url = "ugl"},
	{id = 300, foil = "N", chinese = "N", url = "exo"},
	{id = 290, foil = "N", chinese = "N", url = "sth"},
	{id = 280, foil = "N", chinese = "N", url = "tmp"},
	{id = 270, foil = "N", chinese = "N", url = "wth"},
	{id = 260, foil = "N", chinese = "N", url = "por"},
	{id = 250, foil = "N", chinese = "N", url = "5ed"},
	{id = 240, foil = "N", chinese = "N", url = "vis"},
	{id = 230, foil = "N", chinese = "N", url = "mir"},
	{id = 220, foil = "N", chinese = "N", url = "all"},
	{id = 210, foil = "N", chinese = "N", url = "hml"},
	{id = 200, foil = "N", chinese = "N", url = "chr"},
	{id = 190, foil = "N", chinese = "N", url = "ice"},
	{id = 180, foil = "N", chinese = "N", url = "4ed"},
	{id = 170, foil = "N", chinese = "N", url = "fem"},
	{id = 160, foil = "N", chinese = "N", url = "drk"},
	{id = 150, foil = "N", chinese = "N", url = "leg"},
	{id = 140, foil = "N", chinese = "N", url = "3ed"},
	{id = 130, foil = "N", chinese = "N", url = "atq"},
	{id = 120, foil = "N", chinese = "N", url = "arn"},
	{id = 110, foil = "N", chinese = "N", url = "2ed"},
	{id = 70, foil = "N", chinese = "N", url = "vanguard"},
	{id = 50, foil = "O", chinese = "N", url = "ppr"},
	{id = 25, foil = "O", chinese = "N", url = "ppr"},
	{id = 24, foil = "Y", chinese = "N", url = "ppr"},
	{id = 22, foil = "Y", chinese = "N", url = "ppr"},
	{id = 21, foil = "Y", chinese = "N", url = "ppr"},
	{id = 10, foil = "O", chinese = "N", url = "ppr"},
	{id = 7, foil = "y", chinese = "N", url = "ppr"},
	{id = 5, foil = "N", chinese = "N", url = "ppr"},
	{id = 2, foil = "N", chinese = "N", url = "ppr"},
	{id = 100, foil = "N", chinese = "N", url = "leb"},
	{id =  90, foil = "N", chinese = "N", url = "lea"}
}

-- Table that define a replacement list for card names
namereplace = {
	["Akki Lavarunner"] = "Akki Lavarunner|Tok-Tok, Volcano Born",
	["Æther Tide"] = "AEther Tide",
	["Æther Flash"] = "AEther Flash",
	["Æther Storm"] = "AEther Storm",
	["Ærathi Berserker"] = "AErathi Berserker",
	["Electrolyze - Extended Art"] = "Electrolyze",
	["Rakdos Guildmage - Expanded Art"] = "Rakdos Guildmage",
	["Wax-Wane"] = "Wax|Wane",
	["Honor of the Pure -Prerelease Foil"] = "Honor of the Pure",
	["Memoricide - FNM Foil"] = "Memoricide",
	["Surgical Extraction - FNM Foil"] = "Surgical Extraction",
	["Armageddon - Judge Foil"] = "Armageddon",
	["Balance - Judge Foil"] = "Balance",
	["Ball Lightning - Judge Foil"] = "Ball Lightning",
	["Counterspell - Judge Foil"] = "Counterspell",
	["Gaea's Cradle - Judge Foil"] = "Gaea's Cradle",
	["Gemstone Mine - Judge Foil"] = "Gemstone Mine",
	["Grim Lavamancer - Judge Foil"] = "Grim Lavamancer",
	["Hammer of Bogardan - Judge Foil"] = "Hammer of Bogardan",
	["Lightning Bolt - Judge Foil"] = "Lightning Bolt",
	["Living Death - Judge Foil"] = "Living Death",
	["Mishra's Factory - Judge Foil"] = "Mishra's Factory",
	["Oath of Druids - Judge Foil"] = "Oath of Druids",
	["Pernicious Deed - Judge Foil"] = "Pernicious Deed",
	["Phyrexian Negator - Judge Foil"] = "Phyrexian Negator",
	["Regrowth - Judge Foil"] = "Regrowth",
	["Sol Ring - Judge Foil"] = "Sol Ring",
	["Stroke of Genius - Judge Foil"] = "Stroke of Genius",
	["Time Warp - Judge Foil"] = "Time Warp",
	["Tradewind Rider - Judge Foil"] = "Tradewind Rider",
	["Vampiric Tutor - Judge Foil"] = "Vampiric Tutor",
	["Budoka Gardener"] = "Budoka Gardener|Dokai, Weaver of Life",
	["City of Brass - JSS Foil"] = "City of Brass",
	["Crusade - JSS Foil"] = "Crusade",
	["Elvish Lyrist - JSS Foil"] = "Elvish Lyrist",
	["Giant Growth - JSS Foil"] = "Giant Growth",
	["Lord of Atlantis - JSS Foil"] = "Lord of Atlantis",
	["Serra Avatar - JSS Foil"] = "Serra Avatar",
	["Thran Quarry - JSS Foil"] = "Thran Quarry",
	["Nalathni Dragon - Insert"] = "Nalathni Dragon",
	["Scent of Cinder - Alternate Art"] = "Scent of Cinder",
	["Lightning Hounds - Insert Foil"] = "Lightning Hounds",
	["Warmonger - Insert Foil"] = "Warmonger",
	["Overtaker - Prerelease Foil"] = "Overtaker",
	["Rathi Assassin - Prerelease Foil"] = "Rathi Assassin",
	["Revenant - Prerelease"] = "Revenant",
	["Shield of Kaldra - Prerelease Foil"] = "Shield of Kaldra",
	["Silent Specter - Prerelease Foil"] = "Silent Specter",
	["Soul Collector - Prerelease Foil"] = "Soul Collector",
	["Sword of Kaldra - Prerelease Foil"] = "Sword of Kaldra",
	["Ink-Eyes, Servant of Oni - Prerelease Foil"] = "Ink-Eyes, Servant of Oni",
	["Avatar of Hope - Prerelease Foil"] = "Avatar of Hope",
	["Beast of Burden - Prerelease Foil"] = "Beast of Burden",
	["Dirtcowl Wurm - Prerelease"] = "Dirtcowl Wurm",
	["False Prophet - Prerelease Foil"] = "False Prophet",
	["Feral Throwback - Prerelease Foil"] = "Feral Throwback",
	["Helm of Kaldra - Prerelease Foil"] = "Helm of Kaldra",
	["Gleancrawler - Prerelease Foil"] = "Gleancrawler",
	["Allosaurus Rider - Prerelease Foil"] = "Allosaurus Rider",
	["Lotus Bloom - Prerelease Foil"] = "Lotus Bloom",
	["Oros, the Avenger - Prerelease Foil"] = "Oros, the Avenger",
	["Korlash, Heir to Blackblade - Prerelease Foil"] = "Korlash, Heir to Blackblade",
	["Door of Destinies -Prerelease Foil"] = "Door of Destinies",
	["Rukh Egg - Prerelease Foil"] = "Rukh Egg",
	["Ghost-Lit Raider - Release Foil"] = "Ghost-Lit Raider",
	["Marit Lage Token - Coldsnap Foil"] = "Marit Lage",
	["Force of Nature - Prerelease Foil"] = "Force of Nature",
	["Incinerate - Legend"] = "Incinerate",
	["Arena - Book"] = "Arena",
	["Giant Badger - Book"] = "Giant Badger",
	["Sewers of Estark - Book"] = "Sewers of Estark",
	["Windseeker Centaur - Book"] = "Windseeker Centaur",
	["Budoka Pupil"] = "Budoka Pupil|Ichiga, Who Topples Oaks",
	["Bushi Tenderfoot"] = "Bushi Tenderfoot|Kenzo the Hardhearted",
	["Callow Jushi"] = "Callow Jushi|Jaraku the Interloper",
	["Cunning Bandit"] = "Cunning Bandit|Azamuki, Treachery Incarnate",
	["Curse of the Nightly Haunt"] = "Curse of the Nightly Hunt",
	["DANDÂN"] = "Dandan",
	["Deja Vu"] = "Déjà Vu",
	["Elder Cather"] = "Elder Cathar",
	["Erayo, Soratami Ascendant"] = "Erayo, Soratami Ascendant|Erayo's Essence",
	["Faithful Squire"] = "Faithful Squire|Kaiso, Memory of Loyalty",
	["Fire-Ice"] = "Fire|Ice",
	["Gust Skimmer"] = "Gust-Skimmer",
	["Hired Muscle"] = "Hired Muscle|Scarmaker",
	["Homura, Human Ascendant"] = "Homura, Human Ascendant|Homura's Essence",
	["Hunger of the Wolfpack"] = "Hunger of the Howlpack",
	["Initiate of Blood"] = "Initiate of Blood|Goka the Unjust",
	["Jushi Apprentice"] = "Jushi Apprentice|Tomoya the Revealer",
	["Kitsune Mystic"] = "Kitsune Mystic|Autumn-Tail, Kitsune Sage",
	["Kuon, Ogre Ascendant"] = "Kuon, Ogre Ascendant|Kuon's Essence",
	["Nezumi Graverobber"] = "Nezumi Graverobber|Nighteyes the Desecrator",
	["Nezumi Shortfang"] = "Nezumi Shortfang|Stabwhisker the Odious",
	["Orochi Eggwatcher"] = "Orochi Eggwatcher|Shidako, Broodmistress",
	["Runeclaw Bears"] = "Runeclaw Bear",
	["Rune-Tail, Kitsune Ascendant"] = "Rune-Tail, Kitsune Ascendant|Rune-Tail's Essence",
	["Sasaya, Orochi Ascendant"] = "Sasaya, Orochi Ascendant|Sasaya's Essence",
	["Sharuum, the Hegemon"] = "Sharuum the Hegemon",
	["Student of Elements"] = "Student of Elements|Tobita, Master of Winds",
	["Urabrask, the Hidden"] = "Urabrask the Hidden"
}

-- Table that define a replacement list for foil
foiltweak = {
	{setid = 766, cardname = "Phyrexian Negator", foil = 1},
	{setid = 766, cardname = "Urza's Rage", foil = 1},
}

--[[ Function that download and parse one html file
    set: set record from avsets
setname: set name, needed only for progressbar
   foil: should we parse foil
 langid: language id --]]
function parsehtml(set, setname, foil, langid)
	-- Update progress
	curhtmlnum = curhtmlnum + 1
	local pmesg = "Parsing "
	if langid == 9 then pmesg = pmesg .. "CHN " else pmesg = pmesg .. "ENG " end
	if foil == 1 then pmesg = pmesg .. "FOIL " end
	ma.SetProgress(pmesg .. setname, 100*curhtmlnum/totalhtmlnum)
	-- Construct URL
	local url = "http://www.mtgmintcard.com/mtg/singles/"
	url = url .. set.url
	if langid == 9 then url = url .. "/chi-" else url = url .. "/eng-" end
	if foil == 1 then url = url .. "foil" else url = url .. "reg" end
	ma.Log("Parsing " .. url)
	url = url .. "?page="
	local searchpattern = "class=\"cardBorderBlack\".-<a[^>]+>([^<]+)<.->$([%d.,]+)"
	-- Download page
	for i=1,16 do
		local htmldata = ma.GetUrl(url .. i)
		local found = 0
		if htmldata ~= nil then
			-- Pattern matching, tricky thing, read http://www.lua.org/manual/5.0/manual.html#5.3 for better understanding
			for name, price in string.gmatch(htmldata, searchpattern) do
				if name ~= nil then found = 1 end
				-- Parse card price
				price = string.gsub(price, ",", "")
				-- Parse card name
				name = string.gsub(name, "%(Chinese Version%)", "")
				name = string.gsub(name, "^%s*(.-)%s*$", "%1")
				name = string.gsub(name, "  "," ")
				name = string.gsub(name, " / ","|")
				name = string.gsub(name, " // ","|")
				name = string.gsub(name, "/","|")
				name = string.gsub(name, "Ã†", "AE")
				name = string.gsub(name, "AE", "Æ")
				name = string.gsub(name, "Ã©", "e")
				name = string.gsub(name, "Ã¢", "a")
				name = string.gsub(name, "Ã ", "a")
				name = string.gsub(name, "Â®", "®")
				name = string.gsub(name, "[ ]*%([^']+%)$", "")
				if namereplace[name] ~= nil then name = namereplace[name] end
				-- Check for foil status patch
				-- ma.Log("Getting info. for " .. name .. ": " .. price)
				local foilstat = foil
				for _, rec in ipairs(foiltweak) do
					if rec.setid == set.id and rec.cardname == name then foilstat = rec.foil end
				end
				-- Set the price
				local regprice = 0
				local foilprice = 0
				if foilstat == 1 then foilprice = price else regprice = price end
				local result = ma.SetPrice(set.id, langid, name, "", regprice, foilprice)
				-- If no matches found, try with all versions
				if result == 0 then ma.SetPrice(set.id, langid, name, "*", regprice, foilprice) end
			end
		else
			ma.Log("GetUrl failed for " .. url .. i)
		end
		if found == 0 then break end
	end
end

-- Main startup function
function ImportPrice(importfoil, importlangs, importsets)
	-- Calculate total number of html pages to parse (need this for progress bar)
	totalhtmlnum = 0
	for _, rec in ipairs(avsets) do
		if importsets[rec.id] ~= nil then
			local perlangnum = 0
			if importfoil ~= "O" and rec.foil ~= "O" then perlangnum = perlangnum + 1 end
			if importfoil ~= "N" and rec.foil ~= "N" then perlangnum = perlangnum + 1 end
			if importlangs[1] ~= nil and rec.chinese ~= "O" then totalhtmlnum = totalhtmlnum + perlangnum end
			if importlangs[9] ~= nil and rec.chinese ~= "N" then totalhtmlnum = totalhtmlnum + perlangnum end
		end
	end
	-- Main import cycle
	curhtmlnum = 0
	for _, rec in ipairs(avsets) do
		if importsets[rec.id] ~= nil then
			if importfoil ~= "O" and rec.foil ~= "O" and importlangs[1] ~= nil and rec.chinese ~= "O" then parsehtml(rec, importsets[rec.id], 0, 1) end
			if importfoil ~= "N" and rec.foil ~= "N" and importlangs[1] ~= nil and rec.chinese ~= "O" then parsehtml(rec, importsets[rec.id], 1, 1) end
			if importfoil ~= "O" and rec.foil ~= "O" and importlangs[9] ~= nil and rec.chinese ~= "N" then parsehtml(rec, importsets[rec.id], 0, 9) end
			if importfoil ~= "N" and rec.foil ~= "N" and importlangs[9] ~= nil and rec.chinese ~= "N" then parsehtml(rec, importsets[rec.id], 1, 9) end
		end
	end
end
